import processing.core.*; 
import processing.xml.*; 

import processing.serial.*; 
import ddf.minim.*; 
import processing.net.*; 

import java.applet.*; 
import java.awt.*; 
import java.awt.image.*; 
import java.awt.event.*; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class processing_13 extends PApplet {





Server server;
boolean serverRunning;
char message;

Minim minim;
AudioInput input;
AudioRecorder recorder;
AudioPlayer player;

Serial port;
int data = 0;// changed to stri
boolean messageWaiting = false;// no message from other machine
int DropTimer;
int waitForDrop = 6000;// this sets the delay between string dropping 
int numOfDropsAllowed = 5;// after this do not send message to drop string
int dropCounter=0;// counter for number of string drops
//p = 112   play
//s = 115   stop play
//r = 115   record
//f = 102   finish record
//d = 100   dropstring


public void setup()
{
  // set size
  size(400, 400);
  background(0);

  // make the Minim sound object
  minim = new Minim(this);

  // get a stereo line-in, e.g. from microphone
  input = minim.getLineIn(Minim.STEREO);

  String portName = Serial.list()[1];
  port = new Serial(this, portName, 9600);

  server = new Server(this, 10002); // server
  serverRunning = true; //server


  data = 0;//empty data at start
}

public void draw()
{

  if(serverRunning == true) {    
    //check for the next client in line with a new message
    Client thisClient = server.available();
    //is there a client?
    if(thisClient != null) {
      //check to see if there is a message from the client
      if(thisClient.available() > 0) {
        // read in the message
        String m = thisClient.readString();
        message = m.charAt(0);

        //data = 112;
        // println(data);
        messageWaiting = true;

        dropCounter = 0;//set the counter for the number of times the string drops to 0
        dropString() ;
      }
    }
  } 

  if (messageWaiting == true){
    dropString() ;
  }




  if ( port.available() > 0) {  
    data = port.read();         
  }

  if (data != 0){ 
    dataReceived();
    data = 0;
  }

  // draw the playing waveforms
  if( player != null ) {
    if (player.isPlaying() ) {
      background(0);
      stroke(255);
      for(int i = 0; i < player.left.size()-1; i++)
      {
        line(i, 50 + player.left.get(i)*50, i+1, 50 + player.left.get(i+1)*50);
        line(i, 150 + player.right.get(i)*50, i+1, 150 + player.right.get(i+1)*50);
      }
    }
  }
}


public void dropString() {
  if(millis()>DropTimer){

    dropCounter ++;
    if (dropCounter <= numOfDropsAllowed){
      println("drop");
      port.write(100);//d for dropstring
    }
    else{
      println("string fully extended");
    }
    DropTimer =  millis() + waitForDrop; 
  }


}

public void dataReceived() {
  // check which key was pressed
  println("_" + data);
  switch(data){

  case 'r': // RECORD
    if (player != null) { 
      player.close();
      player = null;
    }
    if (recorder == null){  
      // create recorder and set a filename to save to
      recorder = minim.createRecorder(input, "sound_01.wav", true); 
    }
    recorder.beginRecord();
    background(255,0,0);
    break;

  case 'f': // STOP RECORD 
    if ( recorder != null) {
      if ( recorder.isRecording() ) {        
        recorder.endRecord();
        recorder.save();
        background(0);  
        recorder = null;
      }
    }
    background(0,0,0);
    break;

  case 'p': // PLAY
    messageWaiting = false;// stop dropping the string

    if (player == null){
      // create a player and load the file
      player = minim.loadFile("file://Silvia/tuuli_client/processing_13/sound_01.wav");
    }
    player.rewind();
    player.play();
    break;


  case 's': // STOP PLAY
    if ( player != null) {
      if ( player.isPlaying() ) { 
        player.pause();  
      }    
    }


    break;

  }

}

public void keyPressed() {
  println("key is " +key);
  // check which key was pressed
  switch(key){
  case 'r': // RECORD
    data = 114;
    break;
  case 'f': // STOP RECORD 
    data = 102;
    break;

  case 'p': // PLAY
    data = 112;
    break;
  case 's': // STOP PLAY 
    data = 115;
    break;
  }
}


public void stop()
{
  // always close the Minim object when closing program
  if (player != null) {
    player.close();
  }
  input.close();
  minim.stop();

  super.stop();
}




  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#ebe9ed", "processing_13" });
  }
}
